# Restricted ticket entry module

from trac.core import *
from trac.web.chrome import INavigationContributor
from trac.web import IRequestHandler, IRequestFilter
from trac.perm import IPermissionRequestor, PermissionCache, PermissionSystem
import trac.perm as permc
from trac.util import Markup
from trac.config import ListOption
from types import *
from trac.ticket.web_ui import TicketModule

class SimpleTicketModule(Component):
    """Restricted ticket entry form."""

    hide_fields = ListOption('simpleticket', 'hide', default='', doc='What fields to hide for the simple ticket entry form.')


    implements(IPermissionRequestor,IRequestFilter)

    # IPermissionRequestor methods
    def get_permission_actions(self):
        yield 'TICKET_SIMPLE'

    # IRequestFilter methods
    def pre_process_request(self, req, handler):
        return handler

    def post_process_request(self, req, template, data, content_type):
        # Hide the fields
        if req.perm.has_permission('TICKET_SIMPLE') and not req.perm.has_permission('TRAC_ADMIN'):
            #self.env.log.info(data)
            for f in self.hide_fields:
                if data.has_key('fields'):
                    for dict in data['fields']:
                        if (dict['name'] == f ):
                            self.env.log.info(dict['name'])
                            dict['skip'] = True
                            dict['rendered'] = 'no'
        return template, data, content_type

